<template>
	<div>
		<v-btn
			@click="showSignupForm = !showSignupForm"
			class="mb-6"
		>
			<template v-if="showSignupForm">
				Log In
			</template>
			<template v-else>
				Create an account
			</template>
		</v-btn>
		<v-alert
			v-if="errorMessage"
			type="error"
			dense
      		outlined
			class="mb-6"
		>
			{{ errorMessage }}
		</v-alert>
		<v-slide-y-transition>
			<v-form
				v-if="showSignupForm"
				ref="signupForm"
				v-model="signupForm.valid"
				lazy-validation
			>
				<v-text-field
					label="First Name"
					v-model="signupForm.firstName"
					:rules="validate.require"
				/>
				<v-text-field
					label="Last Name"
					v-model="signupForm.lastName"
					:rules="validate.require"
				/>
				<v-text-field
					label="Email"
					v-model="signupForm.email"
					:rules="[validate.email(signupForm.email)]"
				/>
				<v-text-field
					label="Password"
					v-model="signupForm.password"
					:rules="validate.require"
				/>
				<v-text-field
					label="Confirm Password"
					v-model="signupForm.confirmPassword"
					:rules="[...validate.require, validate.checkConfirmPassword(signupForm.password, signupForm.confirmPassword)]"
				/>
				<div class="mt-6">
					<v-btn
						:disabled="!signupForm.valid"
						color="success"
						class="mr-4"
						@click="signup"
					>
						Submit
					</v-btn>
					<v-btn
						color="error"
						class="mr-4"
						@click="$refs.loginForm.reset()"
					>
						Clear
					</v-btn>
				</div>
			</v-form>
			<v-form
				v-else
				ref="loginForm"
				v-model="loginForm.valid"
				lazy-validation
			>
				<v-text-field
					label="Email"
					v-model="loginForm.email"
					:rules="[validate.email(loginForm.email)]"
				/>
				<v-text-field
					label="Password"
					v-model="loginForm.password"
					:rules="validate.require"
				/>
				<div class="mt-6">
					<v-btn
						:disabled="!loginForm.valid"
						color="success"
						class="mr-4"
						@click="login"
					>
						Log In
					</v-btn>
				</div>
			</v-form>
		</v-slide-y-transition>
	</div>
</template>

<script>
	import validation from '../mixins/validation';
	import fb from '../util/firebase';

	export default {
		mixins: [validation],
		data() {
			return {
				showSignupForm: false,
				showForgetPasswordForm: false,
				loginForm: {
					valid: true,
					email: '',
					password: '',
				},
				signupForm: {
					valid: true,
					firstName: '',
					lastName: '',
					email: '',
					password: '',
					confirmPassword: '',
				},
				errorMessage: '',
				performingRequest: false,
			};
		},
		methods: {
			login() {
				if (!this.$refs.loginForm.validate()) {
					return;
				}
				this.snackbar = true;

				fb.auth.signInWithEmailAndPassword(this.loginForm.email, this.loginForm.password)
					.then(user => {

						this.$store.commit('SET_CURRENT_USER', user.user);
						this.$store.dispatch('fetchUserProfile');
						this.$router.push('/portfolio');

					}).catch(e => {
						this.errorMessage = e.message;
						console.log(e);
					}).finally(() => {

					});
			},
			signup() {
				if (!this.$refs.form.validate()) {
					return;
				}
				
				this.performingRequest = true;

				fb.auth.createUserWithEmailAndPassword(this.signupForm.email, this.signupForm.password)
					.then(user => {
					
						this.$store.commit('SET_CURRENT_USER', user.user)
						
						fb.usersCollection.doc(user.uid).set({
							firstName: this.signupForm.firstName,
							lastName: this.signupForm.lastName,
						}).then(() => {
							this.$store.dispatch('fetchUserProfile');
							this.$router.push('/account');
						}).catch(e => {
							console.log(e);
							this.errorMessage = e.message;
						});
					}).catch(e => {
						console.log(e);
						this.errorMessage = e.message;
					}).finally(() => {
						this.performingRequest = false;
					});
			},
		}
	};
</script>